;;;;;;;;;EZCMP Example Program
;;;;;;EZCMP (c) 1997 by Chris Busch
;;Please read ezcmp.doc file and other ezcmp*.asm files for more details.

#include "ti-85.h"
#define  jp   DONT_USE

;;;;;;The following defines are not needed for EZCMP.  But they are good
;;;;;;for watching registers and thus help you with debugging.
;;;;;;;;;;DEBUG16 macros show 16 bit regs and DEBUG8 macros show 8 bit regs
#define DEBUG16(REG)  push AF \ push BC \ push DE \ push HL \ push IX \ push IY \ push REG \ pop hl \ ld bc,$0000 \ call $8C0F \ .dw printnum \ pop IY \ pop IX \ pop HL \ pop DE \ pop  BC \ pop  AF
#define DEBUG16a(REG) push AF \ push BC \ push DE \ push HL \ push IX \ push IY \ push REG \ pop hl \ ld bc,$0001 \ call $8C0F \ .dw printnum \ pop IY \ pop IX \ pop HL \ pop DE \ pop  BC \ pop  AF
#define DEBUG8(REG)   push AF \ push BC \ push DE \ push HL \ push IX \ push IY \ ld h,0 \ ld l,REG \ ld bc,$0800 \ call $8C0F \ .dw printnum \ pop IY \ pop IX \ pop HL \ pop DE \ pop  BC \ pop  AF
#define DEBUG8a(REG)  push AF \ push BC \ push DE \ push HL \ push IX \ push IY \ ld h,0 \ ld l,REG \ ld bc,$0801 \ call $8C0F \ .dw printnum \ pop IY \ pop IX \ pop HL \ pop DE \ pop  BC \ pop  AF

;;;;;;;;;;;;;These variables are needed by the decompressor
;;;;;These vars can be placed anywhere in TEXT_MEM or TEXT_MEM2 memory.
EZsource   = TEXT_MEM2    ;;word
EZdest     = EZsource   + 2 ;;word
EZdestdone = EZdest     + 2 ;;word
EZpasses   = EZdestdone + 2 ;;byte
EZlookup   = EZpasses   + 1 ;;word


.org 0
.db "EZCMP decoder v0.0 CGB",0
;;;;;;;;;;main
   ld   hl,(PROGRAM_ADDR)
   ld   de,EZCMPtest_objPASSES
	add  hl,de
	CALL_(EZCMPDecodeMPass) ;;Multiple Passes
   ;;;Now both GRAPH and VIDEO memory have the picture.
   ;;;Remember EZCMP can also be used for level data, maps or whatever.
   ;;;If you have data compressed with only a single pass then you may use
   ;;;EZCMPDecodeSPass directly.
wait4key:
   halt ;;I think having halts in waiting loops may save batteries
   call GET_KEY
   or a
   jr z,wait4key
   ret
;;;;;;;;;end main

;;;;;;;;;;;include the multipass decompressor library
#include "ezcmpmp.asm"

;;;;;;;;;;include the compressed file
#include "ezcmptst.asm"

;;printnum(hl=number,b=col,c=row)
;;;;;;;printnum is needed by DEBUG macros but not by EZCMP
printnum:
   ld      (CURSOR_ROW),bc
   ROM_CALL(D_HL_DECI)
   ret
;;;;;;;;end printnum


.END

