;;;;;;;EZCMP Single Pass .asm file
;;;EZCMP Zshell CoMPression library
;;;;;;(c) 1997 by Chris Busch
;;;This file is included by the multiple pass decompressor.
;;;;;;;;;;EZCMPSP_ASM

;;The following variables need to be declared some where.
;;;EZsource start anywhere (like TEXT_MEM for example)
;;EZsource   = TEXT_MEM2    ;;word
;;EZdest     = EZsource   + 2 ;;word
;;EZdestdone = EZdest     + 2 ;;word
;;EZpasses   = EZdestdone + 2 ;;byte
;;EZlookup   = EZpasses   + 1 ;;word

EZshift    = $0F  ;;Nibble shift indicator

;;;;;;EZCMPDecodeSPass( hl->EZCMPdata , de->dest ) ;;single pass decode
;;To compress using only one pass use -s option.
;;No registers are preserved.
;;HL points to the data after the one byte containing the number of passes.
;;HL and de must point to the actual addresses ie PROGRAM_ADDR must have
;;been added if needed.
EZCMPDecodeOPass:  ;;decode for one pass ezcmp aligned compression technique
   ld (EZdest),de
   ld a,(hl) \   ld (EZdestdone),a     \ inc hl   ;;storing count
   ld a,(hl) \   ld (EZdestdone+1),a   \ inc hl   ;;
   ld (EZlookup),hl ;;storing lookup table
   ld bc,15
   add hl,bc
   ld (EZsource),hl  ;;hl=source
   ld  hl,(EZdestdone)
   ld  de,(EZdest)
   add hl,de
   ld  (EZdestdone),hl   ;;will stop decode when reached destdone
EZdecodeloop:
   ld  hl,(EZdest)
   ld de,(EZdestdone)                 ;;{check for completion
   call CP_HL_DE                    ;;
   ret z                            ;;}
;;;;;;;;;;;;;;;;first nibble (msn)
   ld  hl,(EZsource)
   ld  a,(hl)
   srl a \ srl a \ srl a \ srl a  ;;use upper nibble
   cp  EZshift
   jr  nz,EZnotshift
EZisshift: ;;next nibble is run
   ld  hl,(EZsource)
   ld  a,(hl)
   and 0Fh
   inc a
   ld  b,0 \   ld  c,a \ inc hl \   ld  de,(EZdest)
   ldir
   ld  (EZdest),de
   ld  (EZsource),hl
   jr  EZdecodeloop
EZnotshift:
   ld  d,0
	ld  e,a
   ld  hl,(EZlookup)
   add hl,de
   ld  a,(hl) ;;hl-> into lookup table
   ld  hl,(EZdest) \ ld (hl),a \ inc hl \ ld (EZdest),hl
   ld de,(EZdestdone) ;;{check for completion
   call CP_HL_DE    ;; must be done since stream can contain 1 pack nibble
   ret z            ;;}
;;;;;second nibble  (lsn)
   ld  hl,(EZsource)
   ld  a,(hl)
   and 0Fh
   cp  EZshift
   jr  nz,EZnot2shift
EZis2shift:
	ld  hl,(EZsource)
   inc hl
   ld  a,(hl)  ;;fetched next byte
   inc hl
   ld  (EZsource),hl  ;; source+=2
   ld  hl,(EZdest)
   ld  (hl),a      ;;store the next byte
   inc hl
   ld  (EZdest),hl  ;;store destination
EZgotodecodeloop:
   jr EZdecodeloop
EZnot2shift:
   ld  d,0
   ld  e,a
   ld  hl,(EZlookup)
   add hl,de
   ld  a,(hl) ;;hl-> into lookup table
   ld  hl,(EZdest) \ ld (hl),a \ inc hl \ ld (EZdest),hl
   ld  hl,(EZsource) \ inc hl \ ld (EZsource),hl
   jr  EZgotodecodeloop
;;;;;;;;;end ezcmp decode one pass


;;;;;;;;;;;;;;;;;;end of this file
